:: send_ebnaut_ublox (DF6NM 2021-03-23)

:: the ebnaut sequence should be in pskln.txt, generated by "Save Rows" in ebnaut-tx software
:: raster (seconds): transmission starts at multiples of this time interval
::  (will work across midnight, but not into a new month) 
::  (local format of %date% should start with DD. For MM-DD-YYYY, change %t1:~12,2% to %t1:~15,2%) 
:: maxlate (seconds): transmission can be started late, shortly after nominal sequence start time
:: repeats: number of sequences to be sent
:: sym (seconds): symbol duration
:: freq (Hz): tx frequency, should be integer or close to integer Hz, e.g. 8270.0025
:: comport: serial port of GPS device
:: timpulse: select either 0, or 1 (if the GPS device has two clock output pins)

@set raster=1800
@set maxlate=120
@set repeats=3
@set sym=1
@set freq=137477
@set comport=com3
@set timepulse=1

@set tp= 
@if %timepulse% neq 1 set tp= tp
@setubx2 %freq%%tp%>out1.dat
@setubx2 -%freq%%tp%>out0.dat
@setubx2 0%tp%>outoff.dat

:loop
@if %repeats% leq 0 goto :eof
@set t1=%time% %date%
@echo %t1%, %repeats% sequences to do
@set /a st=(1%t1:~12,2%-100)*86400+(1%t1:~0,2%-100)*3600+(1%t1:~3,2%-100)*60+1%t1:~6,2%-100
@set /a st=%st%-%maxlate%
@set /a st=(%st%/%raster%+1)*%raster%
@set cnt=0
@set stn=%st%-1
@for /f %%i in (pskln.txt) do @call :doline %%i
@timeout %sym% >nul
@type outoff.dat >%comport%
@ set /a repeats=%repeats%-1
@goto :loop

:doline
@set t1=%time% %date%
@set /a t2=(1%t1:~12,2%-100)*86400+(1%t1:~0,2%-100)*3600+(1%t1:~3,2%-100)*60+1%t1:~6,2%-100
@set /a dt=%stn%-%t2%
@set /a dts=%dt%-%sym%
@if %dt% gtr %sym% timeout %dt% & set dt=0  
@if %dt% gtr 0 timeout %dt% >nul
@if %dt% geq 0 type out%1.dat >%comport%
@if %dt% geq 0 echo %cnt% %time% %1
@set /a cnt=%cnt%+1
@set /a stn=%sym%*%cnt%+%st%-1
